{
	"schema": "https://iot-ap.ikonke.com/model/product_3059.json",
	"productType": "IRRC",
	"profile": {
		"heartbeat": "3000",
		"productCode": "3059",
		"productName": "红外遥控器proZ3S"
	},
	"services": [{
		"identifier": "set",
		"name": "set",
		"required": true,
		"callType": "async",
		"desc": "属性设置",
		"method": "thing.service.property.set",
		"inputData": [],
		"outputData": []
	}, {
		"identifier": "get",
		"name": "get",
		"required": true,
		"callType": "async",
		"desc": "属性获取",
		"method": "thing.service.property.get",
		"inputData": [],
		"outputData": []
	}, {
		"identifier": "sendCode",
		"name": "发送红外码",
		"required": false,
		"callType": "async",
		"method": "thing.service.sendCode",
		"inputData": [{
			"identifier": "ButtonId",
			"name": "按键id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}],
		"outputData": []
	}, {
		"identifier": "learnCode",
		"name": "学习红外码",
		"required": false,
		"callType": "async",
		"method": "thing.service.learnCode",
		"inputData": [{
			"identifier": "ButtonId",
			"name": "按键id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}],
		"outputData": []
	}, {
		"identifier": "saveCode",
		"name": "保存红外码",
		"required": false,
		"callType": "async",
		"method": "thing.service.saveCode",
		"inputData": [{
			"identifier": "ButtonId",
			"name": "按键id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}],
		"outputData": []
	}, {
		"identifier": "saveRC",
		"name": "保存遥控器",
		"required": false,
		"callType": "async",
		"method": "thing.service.saveRC",
		"inputData": [{
			"identifier": "rcs",
			"name": "遥控器数组",
			"dataType": {
				"type": "array",
				"specs": {
					"size": "128",
					"item": {
						"type": "struct",
						"specs": [{
							"identifier": "ButtonId",
							"name": "按键id",
							"dataType": {
								"type": "int",
								"specs": {
									"min": "0",
									"max": "1000"
								}
							}
						}, {
							"identifier": "ButtonName",
							"name": "按键名字",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}]
					}
				}
			}
		}],
		"outputData": []
	}, {
		"identifier": "getRC",
		"name": "获取遥控器",
		"required": false,
		"callType": "sync",
		"method": "thing.service.getRC",
		"inputData": [],
		"outputData": [{
			"identifier": "rcs",
			"name": "遥控器数组",
			"dataType": {
				"type": "array",
				"specs": {
					"size": "128",
					"item": {
						"type": "struct",
						"specs": [{
							"identifier": "ButtonId",
							"name": "按键id",
							"dataType": {
								"type": "int",
								"specs": {
									"min": "0",
									"max": "1000"
								}
							}
						}, {
							"identifier": "ButtonName",
							"name": "按键名字",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "ButtonIcon",
							"name": "按键图标",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "ButtonStatus",
							"name": "按键图标",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}]
					}
				}
			}
		}]
	}, {
		"identifier": "getBindCodeLib",
		"name": "获取绑定的码库",
		"required": false,
		"callType": "sync",
		"method": "thing.service.getBindCodeLib",
		"inputData": [],
		"outputData": [{
			"identifier": "codeLibs",
			"name": "码库数组",
			"dataType": {
				"type": "array",
				"specs": {
					"size": "128",
					"item": {
						"type": "struct",
						"specs": [{
							"identifier": "CodeLibId",
							"name": "码库id",
							"dataType": {
								"type": "int",
								"specs": {
									"min": "0",
									"max": "1000"
								}
							}
						}, {
							"identifier": "codeLibType",
							"name": "码库类型",
							"dataType": {
								"type": "enum",
								"specs": {
									"0": "无码库",
									"1": "手动学习码库",
									"2": "云端码库",
									"3": "私有码库"
								}
							}
						}, {
							"identifier": "CodeLibName",
							"name": "码库名字",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "DeviceType",
							"name": "设备类型",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "DeviceBrand",
							"name": "设备设备品牌",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "DeviceModel",
							"name": "设备型号",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "pCode",
							"name": "匹配码",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}]
					}
				}
			}
		}]
	}, {
		"identifier": "getCodeLibButtons",
		"name": "获取码库下的遥控器",
		"required": false,
		"callType": "sync",
		"method": "thing.service.getCodeLibButtons",
		"inputData": [{
			"identifier": "CodeLibId",
			"name": "码库id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}],
		"outputData": [{
			"identifier": "rcs",
			"name": "遥控器数组",
			"dataType": {
				"type": "array",
				"specs": {
					"size": "128",
					"item": {
						"type": "struct",
						"specs": [{
							"identifier": "ButtonId",
							"name": "按键id",
							"dataType": {
								"type": "int",
								"specs": {
									"min": "0",
									"max": "1000"
								}
							}
						}, {
							"identifier": "ButtonName",
							"name": "按键名字",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "ButtonIcon",
							"name": "按键图标",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "ButtonStatus",
							"name": "按键图标",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}]
					}
				}
			}
		}]
	}, {
		"identifier": "getLocalCodeLibs",
		"name": "获取本地私有的码库",
		"required": false,
		"callType": "sync",
		"method": "thing.service.getLocalCodeLibs",
		"inputData": [{
			"identifier": "DeviceType",
			"name": "设备类型",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}],
		"outputData": [{
			"identifier": "codeLibs",
			"name": "码库数组",
			"dataType": {
				"type": "array",
				"specs": {
					"size": "128",
					"item": {
						"type": "struct",
						"specs": [{
							"identifier": "CodeLibId",
							"name": "码库id",
							"dataType": {
								"type": "int",
								"specs": {
									"min": "0",
									"max": "1000"
								}
							}
						}, {
							"identifier": "codeLibType",
							"name": "码库类型",
							"dataType": {
								"type": "enum",
								"specs": {
									"0": "无码库",
									"1": "手动学习码库",
									"2": "云端码库",
									"3": "私有码库"
								}
							}
						}, {
							"identifier": "CodeLibName",
							"name": "码库名字",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "DeviceType",
							"name": "设备类型",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "DeviceBrand",
							"name": "设备设备品牌",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "DeviceModel",
							"name": "设备型号",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}, {
							"identifier": "pCode",
							"name": "匹配码",
							"dataType": {
								"type": "text",
								"specs": {
									"length": "255"
								}
							}
						}]
					}
				}
			}
		}]
	}, {
		"identifier": "saveCodeLib",
		"name": "保存本地私有的码库",
		"required": false,
		"callType": "sync",
		"method": "thing.service.saveCodeLib",
		"inputData": [{
			"identifier": "codeLibType",
			"name": "码库类型",
			"dataType": {
				"type": "enum",
				"specs": {
					"0": "无码库",
					"1": "手动学习码库",
					"2": "云端码库",
					"3": "私有码库"
				}
			}
		}, {
			"identifier": "CodeLibName",
			"name": "码库名字",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "DeviceType",
			"name": "设备类型",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "DeviceBrand",
			"name": "设备设备品牌",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "DeviceModel",
			"name": "设备型号",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "pCode",
			"name": "匹配码",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}],
		"outputData": [{
			"identifier": "CodeLibId",
			"name": "码库id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}]
	}, {
		"identifier": "deleteCodeLib",
		"name": "删除本地私有的码库",
		"required": false,
		"callType": "sync",
		"method": "thing.service.deleteCodeLib",
		"inputData": [{
			"identifier": "CodeLibId",
			"name": "码库id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}],
		"outputData": []
	}, {
		"identifier": "matchCodeLib",
		"name": "匹配码库",
		"required": false,
		"callType": "sync",
		"method": "thing.service.matchCodeLib",
		"inputData": [{
			"identifier": "DeviceType",
			"name": "设备类型",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}],
		"outputData": [{
			"identifier": "CodeLibId",
			"name": "码库id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}, {
			"identifier": "codeLibType",
			"name": "码库类型",
			"dataType": {
				"type": "enum",
				"specs": {
					"0": "无码库",
					"1": "手动学习码库",
					"2": "云端码库",
					"3": "私有码库"
				}
			}
		}, {
			"identifier": "CodeLibName",
			"name": "码库名字",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "DeviceType",
			"name": "设备类型",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "DeviceBrand",
			"name": "设备设备品牌",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "DeviceModel",
			"name": "设备型号",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "pCode",
			"name": "匹配码",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}]
	}, {
		"identifier": "downloadLibCode",
		"name": "下载红外码库到设备",
		"required": false,
		"callType": "sync",
		"method": "thing.service.downloadLibCode",
		"inputData": [{
			"identifier": "CodeLibId",
			"name": "码库id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}, {
			"identifier": "codeLibType",
			"name": "码库类型",
			"dataType": {
				"type": "enum",
				"specs": {
					"0": "无码库",
					"1": "手动学习码库",
					"2": "云端码库",
					"3": "私有码库"
				}
			}
		}, {
			"identifier": "CodeLibName",
			"name": "码库名字",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "DeviceType",
			"name": "设备类型",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "DeviceBrand",
			"name": "设备设备品牌",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "DeviceModel",
			"name": "设备型号",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}, {
			"identifier": "pCode",
			"name": "匹配码",
			"dataType": {
				"type": "text",
				"specs": {
					"length": "255"
				}
			}
		}],
		"outputData": []
	}, {
		"identifier": "testLibCode",
		"name": "测试红外码库",
		"required": false,
		"callType": "sync",
		"method": "thing.service.testLibCode",
		"inputData": [{
			"identifier": "CodeLibId",
			"name": "码库id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}, {
			"identifier": "ButtonId",
			"name": "按键id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}],
		"outputData": []
	}, {
		"identifier": "resetBindCodeLib",
		"name": "重置红外码库",
		"required": false,
		"callType": "sync",
		"method": "thing.service.resetBindCodeLib",
		"inputData": [],
		"outputData": []
	}],
	"properties": [{
		"identifier": "ButtonId",
		"name": "按键id",
		"accessMode": "r",
		"required": true,
		"dataType": {
			"type": "int",
			"specs": {
				"min": "0",
				"max": "1000"
			}
		}
	}, {
		"identifier": "ButtonName",
		"name": "按键名字",
		"accessMode": "rw",
		"required": true,
		"dataType": {
			"type": "text",
			"specs": {
				"length": "255"
			}
		}
	}, {
		"identifier": "ButtonIcon",
		"name": "按键图标",
		"accessMode": "rw",
		"required": true,
		"dataType": {
			"type": "text",
			"specs": {
				"length": "255"
			}
		}
	}, {
		"identifier": "ButtonStatus",
		"name": "按键学习状态",
		"accessMode": "rw",
		"required": false,
		"dataType": {
			"type": "enum",
			"specs": {
				"0": "未学习",
				"1": "已学习"
			}
		}
	}, {
		"identifier": "CodeLibId",
		"name": "码库id",
		"accessMode": "r",
		"required": true,
		"dataType": {
			"type": "int",
			"specs": {
				"min": "0",
				"max": "1000"
			}
		}
	}, {
		"identifier": "codeLibType",
		"name": "码库类型",
		"accessMode": "rw",
		"required": false,
		"dataType": {
			"type": "enum",
			"specs": {
				"0": "无码库",
				"1": "手动学习码库",
				"2": "云端码库",
				"3": "私有码库"
			}
		}
	}, {
		"identifier": "CodeLibName",
		"name": "码库名字",
		"accessMode": "rw",
		"required": true,
		"dataType": {
			"type": "text",
			"specs": {
				"length": "255"
			}
		}
	}, {
		"identifier": "DeviceType",
		"name": "设备类型",
		"accessMode": "rw",
		"required": true,
		"dataType": {
			"type": "text",
			"specs": {
				"length": "255"
			}
		}
	}, {
		"identifier": "DeviceBrand",
		"name": "设备设备品牌",
		"accessMode": "rw",
		"required": true,
		"dataType": {
			"type": "text",
			"specs": {
				"length": "255"
			}
		}
	}, {
		"identifier": "DeviceModel",
		"name": "设备型号",
		"accessMode": "rw",
		"required": true,
		"dataType": {
			"type": "text",
			"specs": {
				"length": "255"
			}
		}
	}, {
		"identifier": "pCode",
		"name": "匹配码",
		"accessMode": "rw",
		"required": true,
		"dataType": {
			"type": "text",
			"specs": {
				"length": "255"
			}
		}
	}],
	"events": [{
		"identifier": "post",
		"name": "post",
		"type": "info",
		"required": true,
		"desc": "属性上报",
		"method": "thing.event.property.post",
		"outputData": []
	}, {
		"identifier": "LearnCodeNotify",
		"name": "学习码库通知消息",
		"type": "info",
		"required": true,
		"method": "thing.event.LearnCodeNotify.post",
		"outputData": [{
			"identifier": "ButtonId",
			"name": "按键id",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "1000"
				}
			}
		}]
	}, {
		"identifier": "DownloadLibCodeNotify",
		"name": "下载码库通知消息",
		"type": "info",
		"required": true,
		"method": "thing.event.DownloadLibCodeNotify.post",
		"outputData": [{
			"identifier": "Process",
			"name": "码库下载进度",
			"dataType": {
				"type": "int",
				"specs": {
					"min": "0",
					"max": "100"
				}
			}
		}]
	}]
}